<?php
if(!defined("B_PROLOG_INCLUDED") || B_PROLOG_INCLUDED!==true) die();

if(!class_exists("CBXPrivateDownload"))
{
    class CBXPrivateDownload
    {
        private static $arParams = array();
        private static $arResult = array();
        
        public static function Init($arParams, $arResult)
        {
            self::$arParams = $arParams;
            self::$arResult = $arResult;
        }
        
        public static function GetFileList()
        {
            global $USER, $APPLICATION;
            $arFiles = array();
            
            if($handle = @opendir($_SERVER["DOCUMENT_ROOT"].'/'.self::$arParams["REAL_PATH"]))
            {
                while(false !== ($file = @readdir($handle)))
                {
                    if($file == "." || $file == ".." || !is_file($_SERVER["DOCUMENT_ROOT"].'/'.self::$arParams["REAL_PATH"].'/'.$file)) continue;
                    
                    $FSize = filesize($_SERVER["DOCUMENT_ROOT"].'/'.self::$arParams["REAL_PATH"].'/'.$file);
                    $arFiles[] = array(
                        "NAME" => $file,
                        "FULL_PATH" => str_replace("//","/",$_SERVER["DOCUMENT_ROOT"].'/'.self::$arParams["REAL_PATH"].'/'.$file),
                        "SHORT_PATH" => str_replace("//","/",'/'.self::$arParams["REAL_PATH"].'/'.$file),
                        "EXTENSION" => GetFileExtension($file),
                        "PERMISSION" => $APPLICATION->GetFileAccessPermission(str_replace("//","/",'/'.self::$arParams["REAL_PATH"].'/'.$file), $USER->GetUserGroupArray()),
                        "SIZE" => $FSize,
                        "~SIZE" => CFile::FormatSize($FSize),
                        "DOWNLOAD" => str_replace("#FILE_NAME#",$file,str_replace('//','/',self::$arResult["FOLDER"].'/'.self::$arResult["URL_TEMPLATES"]["download"])),
                    );
                }
            }
            
            return $arFiles;
        }
        
        public static function DownloadProcess()
        {
            $arRequestedFile = array(
                "NAME" => self::$arResult["VARIABLES"]["FILE_NAME"],
                "FULL_PATH" => $_SERVER["DOCUMENT_ROOT"].self::$arParams["REAL_PATH"].'/'.self::$arResult["VARIABLES"]["FILE_NAME"],
                "SHORT_PATH" => self::$arParams["REAL_PATH"].'/'.self::$arResult["VARIABLES"]["FILE_NAME"],
            );
            
            if(!file_exists($arRequestedFile["FULL_PATH"]) || !is_file($arRequestedFile["FULL_PATH"]) || !strlen($arRequestedFile["NAME"])>0)
            {
                CHTTP::SetStatus("404 Not Found");
                return "NF";
            }

            @set_time_limit(0);
            global $APPLICATION, $USER;
            
            $arRequestedFile["PERMISSIONS"] = $APPLICATION->GetFileAccessPermission($arRequestedFile["SHORT_PATH"], $USER->GetUserGroupArray());
            if(strlen($arRequestedFile["PERMISSIONS"])==0)
                $arRequestedFile["PERMISSIONS"] = "D";

            if($arRequestedFile["PERMISSIONS"]<"R")
            {
                return "NP";
            }
            else
            {
                if(self::$arParams["NGINX"] == "Y")
                {
                    header("X-Accel-Redirect: ".$arRequestedFile["SHORT_PATH"]);
                    header("Content-Type: application/force-download;");
                    header('Content-Disposition: attachment; filename="'.$arRequestedFile["NAME"].'"');
                }
                else
                {
                    $arRequestedFile["SIZE"] = filesize($arRequestedFile["FULL_PATH"]);
                    $f = fopen($arRequestedFile["FULL_PATH"], "rb");
                    $curPos = 0;
                    $size = $arRequestedFile["SIZE"]-1;

                    if($_SERVER["REQUEST_METHOD"]=="HEAD")
                    {
                        CHTTP::SetStatus("200 OK");
                        header("Accept-Ranges: bytes");
                        header("Content-Length: ".$arRequestedFile["SIZE"]);
                        header("Content-Type: application/force-download; name=\"".$arRequestedFile["NAME"]."\"");
                        header("Last-Modified: ".date("r",filemtime($arRequestedFile["FULL_PATH"])));
                    }
                    else
                    {
                        $APPLICATION->RestartBuffer();
                        $p = strpos($_SERVER["HTTP_RANGE"], "=");
                        if(intval($p)>0)
                        {
                            $bytes = substr($_SERVER["HTTP_RANGE"], $p+1);
                            $p = strpos($bytes, "-");
                            if($p!==false)
                            {
                                $curPos = IntVal(substr($bytes, 0, $p));
                                $size = IntVal(substr($bytes, $p+1));
                                if($size<=0)
                                    $size = $arRequestedFile["SIZE"] - 1;
                                if($curPos>$size)
                                {
                                    $curPos = 0;
                                    $size = $arRequestedFile["SIZE"] - 1;
                                }
                                fseek($f, $curPos);
                            }
                        }

                        if(intval($curPos)>0)
                            CHTTP::SetStatus("206 Partial Content");
                        else
                        {
                            session_cache_limiter('');
                            session_start();
                            if(self::$arParams["KEEP_STATISTIC"]=="Y" && CModule::IncludeModule("statistic") && intval($_SESSION["SESS_SEARCHER_ID"]) <= 0)
                            {
                                if(strlen($event1)<=0 && strlen($event2)<=0)
                                {
                                    $event1 = "download";
                                    $event2 = "private";
                                    $event3 = $arRequestedFile["NAME"];
                                }
                                $e = $event1."/".$event2."/".$event3;
                                if(!in_array($e, $_SESSION["DOWNLOAD_EVENTS"])) // проверим не скачивался ли в данной сессии
                                {
                                    $w = CStatEvent::GetByEvents($event1, $event2);
                                    $wr = $w->Fetch();
                                    $z = CStatEvent::GetEventsByGuest($_SESSION["SESS_GUEST_ID"], $wr["EVENT_ID"], $event3, 21600);
                                    if(!($zr=$z->Fetch())) // проверим не скачивал ли посетитель за последние 6 часов
                                    {
                                        CStatistic::Set_Event($event1, $event2, $event3);
                                        $_SESSION["DOWNLOAD_EVENTS"][] = $e;
                                    }
                                }
                            }
                            session_write_close();
                            CHTTP::SetStatus("200 OK");
                        }

                        header('Content-Disposition: attachment; filename="'.$arRequestedFile["NAME"].'"');
                        header("Content-Type: application/force-download; name=\"".$arRequestedFile["NAME"]."\"");
                        header("Content-Transfer-Encoding: binary");
                        header("Content-Length: ".($size-$curPos+1));
                        header("Accept-Ranges: bytes");
                        header("Content-Range: bytes ".$curPos."-".$size."/".$arRequestedFile["SIZE"]);
                        header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
                        header("Expires: 0");
                        header("Pragma: public");

                        while($curPos<=$size)
                        {
                            $bufsize = 32768;
                            if($bufsize+$curPos>$size)
                                    $bufsize = $size - $curPos + 1;
                            $curPos += $bufsize;
                            $p = fread($f, $bufsize);
                            echo $p;
                            flush();
                        }
                        fclose ($f);
                    }
                    die();
                }                
            }
        }
    }
}

$arDefaultUrlTemplates404 = array(
    "index" => "",
    "download" => "files/#FILE_NAME#",
);

$arDefaultVariableAliases404 = array();
$arDefaultVariableAliases = array();
$componentPage = "";

$arComponentVariables = array(
    "FILE_NAME", 
);

if($arParams["SEF_MODE"] == "Y")
{
    $arVariables = array();

    $arUrlTemplates = CComponentEngine::MakeComponentUrlTemplates($arDefaultUrlTemplates404, $arParams["SEF_URL_TEMPLATES"]);
    $arVariableAliases = CComponentEngine::MakeComponentVariableAliases($arDefaultVariableAliases404, $arParams["VARIABLE_ALIASES"]);

    $componentPage = CComponentEngine::ParseComponentPath(
        $arParams["SEF_FOLDER"],
        $arUrlTemplates,
        $arVariables
    );

    if(!$componentPage)
        $componentPage = "index";

    CComponentEngine::InitComponentVariables($componentPage, $arComponentVariables, $arVariableAliases, $arVariables);

    $arResult = array(
        "FOLDER" => $arParams["SEF_FOLDER"],
        "URL_TEMPLATES" => $arUrlTemplates,
        "VARIABLES" => $arVariables,
        "ALIASES" => $arVariableAliases,
    );
}
else
{
    $arVariableAliases = CComponentEngine::MakeComponentVariableAliases($arDefaultVariableAliases, $arParams["VARIABLE_ALIASES"]);
    CComponentEngine::InitComponentVariables(false, $arComponentVariables, $arVariableAliases, $arVariables);

    $componentPage = "index";
    
    if(isset($arVariables["FILE_NAME"]) && strlen($arVariables["FILE_NAME"]) > 0)
        $componentPage = "download";
    
    $arResult = array(
        "FOLDER" => "",
        "URL_TEMPLATES" => Array(
            "index" => htmlspecialchars($APPLICATION->GetCurPage()),
            "download" => htmlspecialchars($APPLICATION->GetCurPage()."?".$arVariableAliases["FILE_NAME"]."=#FILE_NAME#"),
        ),
        "VARIABLES" => $arVariables,
        "ALIASES" => $arVariableAliases
    );    
}

CBXPrivateDownload::Init($arParams, $arResult);
$this->IncludeComponentTemplate($componentPage);